<template>
  <div
    v-if="gameEntries.length > 0"
    class="black-game-list-entry w-full mb-10 mt-6 px-3"
  >
    <template v-for="game in gameEntries" :key="game.GameId">
      <horizontal-game-entry
        v-if="isLiveCasinoEnabled"
        :game="game"
        @onClick="handleGameSelected(game.GameId)"
      />
      <vertical-game-entry-component
        v-else
        :game="game"
        @onClick="handleGameSelected(game.GameId)"
      />
    </template>
  </div>
  <div
    v-else
    class="my-[60px] mx-4 break-words overflow-hidden text-lg text-center no-data w-full"
  >
    {{ $t("no_games_please_come_back_later") }}
  </div>
  <theme-common-login-dialog v-model="dialog"></theme-common-login-dialog>
</template>
<script lang="ts">
import { defineComponent, computed, ref } from "vue";
import _ from "lodash";
import HorizontalGameEntry from "./HorizontalGameEntry.client.vue";
import VerticalGameEntryComponent from "./VeritcalGameEntry.client.vue";
import { store } from "@/store";
import {
  handleGameEntryOpenWindow,
  useGameEntryBaseOnTabSelected,
} from "@/composables/useTheme";
import EnumEntranceLocation from "@/models/enums/enumEntranceLocation";

export default defineComponent({
  name: "GameListEntryComponent",
  components: {
    HorizontalGameEntry,
    VerticalGameEntryComponent,
  },
  setup() {
    const authenticated = computed(() => store.state.auth);
    const isGameLoading = computed(() => store.state.isGameUpdateLoading);
    const router = useRouter();
    const {
      gameEntrySelected,
      customizeObjectCasinos,
      customizeObjectVirtuals,
      customizeObjectKeno,
      customizeObjectPoker,
      customizeObjectLottery,
    } = useGameEntryBaseOnTabSelected();
    const tabTypeForRoute = computed(() => {
      let result = "";
      gameEntrySelected.value.forEach((item) => {
        result = item?.TabType.replaceAll(" ", "-").toLowerCase();
      });
      return result === ""
        ? `?entrance=${EnumEntranceLocation.GameLobby}`
        : `?tab=${result}&entrance=${EnumEntranceLocation.GameLobby}`;
    });
    const selectedTheme = computed((): string => store.state.selectedThemeName);
    const isLiveCasinoEnabled = computed((): boolean =>
      !_.isEmpty(gameEntrySelected.value)
        ? gameEntrySelected.value[0].Category === 2
        : false
    );
    const route = useRoute();
    const gameEntries = computed(() => {
      // if (isLiveCasinoEnabled.value && selectedTheme.value === "black") {
      //   return customizeObjectCasinos.value;
      // }
      if (
        route.name === "VirtualSportInitial" &&
        selectedTheme.value === "black"
      ) {
        return customizeObjectVirtuals.value;
      }
      if (route.name === "KenoInitial" && selectedTheme.value === "black") {
        return customizeObjectKeno.value;
      }
      if (route.name === "PokerInitial" && selectedTheme.value === "black") {
        return customizeObjectPoker.value;
      }
      if (route.name === "LotteryInitial" && selectedTheme.value === "black") {
        return customizeObjectLottery.value;
      }
      return gameEntrySelected.value;
    });
    const dialog = ref(false);
    const handleGameSelected = (GameId: number) => {
      if (authenticated.value) {
        router.push(`/Game/${GameId}${tabTypeForRoute.value}`);
      } else {
        dialog.value = true;
      }
    };
    return {
      authenticated,
      isGameLoading,
      gameEntrySelected,
      customizeObjectCasinos,
      handleGameEntryOpenWindow,
      EnumEntranceLocation,
      tabTypeForRoute,
      selectedTheme,
      gameEntries,
      dialog,
      handleGameSelected,
      isLiveCasinoEnabled,
    };
  },
});
</script>
<style scoped>
.black-game-list-entry {
  display: flex;
  flex-wrap: wrap;
  gap: 6px 6px;
}
.black-game-list-entry > div:not(.no-data) {
  width: calc(50% - 4px);
}
</style>
